/*
 * Copyright (c) 2008-2019, Hazelcast, Inc. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef HAZELCAST_CLIENT_AWS_AWSCLIENT_H_
#define HAZELCAST_CLIENT_AWS_AWSCLIENT_H_

#include <string>
#include <map>

#include "hazelcast/util/HazelcastDll.h"

#if  defined(WIN32) || defined(_WIN32) || defined(WIN64) || defined(_WIN64)
#pragma warning(push)
#pragma warning(disable: 4251) //for dll export	
#endif

namespace hazelcast {
    namespace util {
        class ILogger;
    }
    namespace client {
        namespace config {
            class ClientAwsConfig;
        }
        namespace aws {
            class HAZELCAST_API AWSClient {
            public:
                AWSClient(config::ClientAwsConfig &awsConfig, util::ILogger &logger);

                std::map<std::string, std::string> getAddresses();

            private:
                config::ClientAwsConfig &awsConfig;
                std::string endpoint;
                util::ILogger &logger;
            };
        }
    }
}

#if  defined(WIN32) || defined(_WIN32) || defined(WIN64) || defined(_WIN64)
#pragma warning(pop)
#endif

#endif /* HAZELCAST_CLIENT_AWS_AWSCLIENT_H_ */
